/* properties_xfig.h */
/* spec for xfig ascii file and set values */

#define BLACK   0
#define BLUE    1
#define GREEN   2
#define CYAN    3
#define RED     4
#define MEGENTA 5
#define YELLOW  6
#define WHITE   7

#define LEFT  0
#define CENTERED 1
#define RIGHT 2
#define UP    3
#define DOWN  4




/*#define LINE 2 1 */
#define WIDTH_POS 4 /* should be 3 ?? */
#define LINE_STYLE_POS 2 /* 0..n */
#define SOLID  0
#define DASHED 1
#define DOTTED 2

#define DEEPNESS_POS_POLYGON 6  /* # 0..1000 (POS 0 to N ) */
#define WIDTH_POS_POLYGON 3
#define POLYGON_POS_X1_COORD 1
#define POLYGON_POS_Y1_COORD 2
#define POLYGON_POS_X6_COORD 11
#define POLYGON_POS_Y6_COORD 12

#define FONT_JUSITFICATION_POS_TEXT  1
#define FONT_COLOR_POS_TEXT      2
#define DEEPNESS_POS_TEXT    3  /* # 0..1000 (POS 0 to N ) */
#define FONT_SIZE_POS_TEXT       6
#define FONT_TYPE_POS_TEXT       5 /* 2:times 0:times-bold */
#define FONT_ROTATE_POS_TEXT 7 /* 0.0000 3.1415 in rad %1.4f */
#define FONT_POS_X_COORD 11   /* xfig coordinates */
#define FONT_POS_Y_COORD 12


#define PEN_COLOR_POS 4 /* pos 0 .. n */
#define FILL_COLOR_POS 6
#define FILL_STYLE_POS 9
#define DASH_LENGHT_POS 10
#define NUMBER_OF_POINTS_POS 16


/* define deepness of function elements on converting fig2dek */
#define BOX_DEEPNESS 100
#define BOX_WIDTH    1
#define BOX_TEXT_SIZE 14
#define BOX_TEXT_ROTATE 0 /* 0 degrees to pi 3.1415 */
#define BOX_TEXT_JUSITFICATION 1 /* 0:left 1:middle  */

#define CONNECTION_DEEPNESS 5 /* connection have to in deepness 5 */
#define CONNECTION_DEEPNESS_01 20
#define CONNECTION_DEEPNESS_02 21
#define CONNECTION_DEEPNESS_03 22
#define CONNECTION_DEEPNESS_04 23
#define CONNECTION_DEEPNESS_05 24
#define CONNECTION_DEEPNESS_06 25
#define CONNECTION_DEEPNESS_00 999 


