#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include  "global.h"
#include  "properties_xfig.h"

#define FIX_BOXES 1 /* manipulates properties of boxes */


/*
001114 if (no>OUT_MAX) exit
       input_max declared
011001 properties_xfig added box properties edited , add int fix_boxes()
*/

int substitute_property_in_xfig_object(char ***line_word_array,int i_line,
              char *CharField_substitute,int *point,int prop_pos,int setvalue);
int WriteDotXfigBox(char ***line_word_array,int i_line);
int fix_boxes(char ***line_word_array,int i_line,char *CharField_substitute);

/*---------------------------read_box ,output,input-box----------*/
int read_box(char ***line_word_array,int i_line,int unit_read_flag,
             int ***input_box,int ***output_box,int current_unit,
             int input_max,char *CharField_substitute)
{
const int a=0; /*-----------------ANALYSE-PRINTS with a=1!!!!!*/
int no=0,x1,x2,y1,y2;
int orientation;
/*--------------------------- searching in1,in2..keyword*/
 /* string to integer in i_line+2, 13th  word, letter-offset=0 */
 no=str2int(line_word_array,i_line,2,13,0);
 if (no==-1) { printf("no input- or output-box \n");
		return -1;
	     }

 if (a) printf("line:%d unit:%d reading inp %d \n",i_line,current_unit,no);
 if (no>OUT_MAX)  { 
    printf("read_box: out:%d>OUT_MAX:%d out of range i_unit:%d i_line:%d\n"
           ,no,OUT_MAX,current_unit,i_line);
  exit (-1);    
  }
 /*write  box-command-line to [0] */

 /* rewrite some properties of boxes : BOX_DEEPNESS, */
 if (FIX_BOXES) fix_boxes(line_word_array,i_line,CharField_substitute);

 /* get click-box (input or output-box) */
 x1=get_upper_left (line_word_array,i_line,1,3,5,7,9);
 y1=get_upper_left (line_word_array,i_line,2,4,6,8,10);
 x2=get_lower_right(line_word_array,i_line,1,3,5,7,9);
 y2=get_lower_right(line_word_array,i_line,2,4,6,8,10);
 
     /* check_input_box returns yes=1-->input_box  or no=-1-->outputbox */
 if ( check_input_box(line_word_array,i_line,x1,y1,x2,y2,&orientation)==1)
     { 
       if (no>input_max)
        { printf("line:%d unit:%d reading inp %d > input_max:%d from info-field\n"
          ,i_line,current_unit,no,input_max); exit (-1); }
       input_box[current_unit][no][0]=i_line+1;
       input_box[current_unit][no][1]=x1;
       input_box[current_unit][no][2]=y1;
       input_box[current_unit][no][3]=x2;
       input_box[current_unit][no][4]=y2;
       if (a) printf("input_box_x1_y1_x2_y2[unit:%d][no:%d]:%d,%d"
		     ",%d,%d    in line:%d\n",
		     current_unit,no,
		     input_box[current_unit][no][1],
		     input_box[current_unit][no][2],
		     input_box[current_unit][no][3],
		     input_box[current_unit][no][4],
		     input_box[current_unit][no][0]
                    );
     }
 else  /* otherwise it should be an output-box ?! */
     {
 if (a) printf("reading inp %d done\n",no);
       output_box[current_unit][no][0]=i_line+1;
       output_box[current_unit][no][1]=x1;
       output_box[current_unit][no][2]=y1;
       output_box[current_unit][no][3]=x2;
       output_box[current_unit][no][4]=y2;
       if (a) printf("output_box_x1_y1_x2_y2[unit:%d][no:%d]:%d,%d"
		     ",%d,%d    in line:%d\n",
		     current_unit,no,
		     output_box[current_unit][no][1],
		     output_box[current_unit][no][2],
		     output_box[current_unit][no][3],
		     output_box[current_unit][no][4],
		     output_box[current_unit][no][0]
                    );
     }

return (1);
} /* read_box() */
/*--------------------------------------------------------------------*/






/*-----------------------get_upper_left of polygon--------------------*/
int get_upper_left(char ***line_word_array,int i_line
		   ,int co1,int co2,int co3,int co4,int co5
		  )
{
int x1,x2;
/* co1..co5 =word1 .. word5 in line */

   /*------ put x1 coordinates upper left of the box---------- */
    /* remember old version: (int) strtod(line_word_array[i_line+1][co1],&rest); */
   x1=atoi(line_word_array[i_line+1][co1]);
   x2=atoi(line_word_array[i_line+1][co2]);if ( x2 < x1 ) x1 = x2;
   x2=atoi(line_word_array[i_line+1][co3]);if ( x2 < x1 ) x1 = x2;
   x2=atoi(line_word_array[i_line+1][co4]);if ( x2 < x1 ) x1 = x2;
   x2=atoi(line_word_array[i_line+1][co5]);if ( x2 < x1 ) x1 = x2;
return (x1);
}
/*--------------------------------------------------------------------*/

/*-----------------------get_lower_right of polygon--------------------*/
int get_lower_right(char ***line_word_array,int i_line
		   ,int co1,int co2,int co3,int co4,int co5
		  )
{
int x1,x2;
/* co1..co5 =word1 .. word5 in line */

   /*------ put x1 coordinates upper left of the box---------- */
   x1=atoi(line_word_array[i_line+1][co1]);
   x2=atoi(line_word_array[i_line+1][co2]);if ( x2 > x1 ) x1 = x2;
   x2=atoi(line_word_array[i_line+1][co3]);if ( x2 > x1 ) x1 = x2;
   x2=atoi(line_word_array[i_line+1][co4]);if ( x2 > x1 ) x1 = x2;
   x2=atoi(line_word_array[i_line+1][co5]);if ( x2 > x1 ) x1 = x2;
return (x1);
}
/*--------------------------------------------------------------------*/

/* -----str2int(line_word_array,i_line,2,13,3);-------*/
/*-----------------------str2int -----------------------------*/
int str2int(char ***line_word_array,int i_line
	    ,int line_offset,int word,int letter_offset)
{
int no=-1;

   switch ((char) line_word_array[i_line+line_offset][word][letter_offset])
     {
     case '0': no=0; break;
     case '1': no=1; break;
     case '2': no=2; break;
     case '3': no=3; break;
     case '4': no=4; break;
     case '5': no=5; break;
     case '6': no=6; break;
     case '7': no=7; break;
     case '8': no=8; break;
     case '9': no=9; break;
     default:  printf("wrong number in input or out-box in line:%d\n",
                       i_line+line_offset); exit(-1);
     }
   switch ((char) line_word_array[i_line+line_offset][word][letter_offset+1])
     {
     case '0': no=no*10  ; break;
     case '1': no=no*10+1; break;
     case '2': no=no*10+2; break;
     case '3': no=no*10+3; break;
     case '4': no=no*10+4; break;
     case '5': no=no*10+5; break;
     case '6': no=no*10+6; break;
     case '7': no=no*10+7; break;
     case '8': no=no*10+8; break;
     case '9': no=no*10+9; break;
     default:  break; /* inp_no < 10 ! */
     }
return (no);
}

/*--------------------------------------------------------------------*/
/* compare all points of the polygon with the connection-box-
   coordinates : if there's a seperate point , which has no common
		 coordinates then this point
		 is inside or outside of the connection-box 
   orientation defines direction left,right,up,down
*/

int check_input_box(char ***line_word_array,int i_line
		    ,int x1,int y1,int x2,int y2,int *orientation)
 {
   int check =-1;
   int single_x=0,single_y=0,single_word_x=0,single_word_y=0;
   int x,y;
   int i_word;
   int horizontal_box=0;

   for (i_word=1;i_word<=9;i_word+=2) /* scan all x-words in i_line+1 */
    {
    single_x=atoi(line_word_array[i_line+1][i_word]);
    if (  (single_x != x1 ) && (single_x != x2 ) ) {
       single_word_x=i_word; /* store no of word */
       x=single_x;
       }
    } /* i_word */
   for (i_word=2;i_word<=10;i_word+=2)
    {
    single_y=atoi(line_word_array[i_line+1][i_word]);
    if (  (single_y != y1 ) && (single_y != y2 ) ) {
       single_word_y=i_word; /* store no of word */
       y=single_y;
       }
    } /* i_word */
   
    /* check x-word-position and y-word-position */
    if ( single_word_y==single_word_x+1 ) check=1;

    if ( abs( x1-x2) > abs (y1-y2) ) horizontal_box=1;
    if (check!=1) { /* output box */
     if (horizontal_box) { if (abs(x-x2)<abs(x-x1)) *orientation=RIGHT;
                           else                     *orientation=LEFT; }
     else { /* this is a vertical box */
       if (abs(y-y2)<abs(y-y1)) *orientation=DOWN;
       else                     *orientation=UP;
     } /* vertical box */
    } /* output box */
    else { /* input box */
     if (horizontal_box) { 
       if (abs(x-x2)<abs(x-x1)) *orientation=RIGHT;
       else                     *orientation=LEFT; 
     } /* horizontal_box */
     else { /* this is a vertical box */
       if (abs(y-y2)<abs(y-y1)) *orientation=DOWN;
       else                     *orientation=UP;
     }
    } /* input box */
if (0) printf("\nx1:%d y1:%d x2:%d y2:%d x:%d y:%d\n",
x1,y1,x2,y2,x,y);

if (0) printf("outbox:orientation:%d\n",*orientation);


 return (check); /* returns yes=1-->input_box  or no=-1-->outputbox */
 } /* check_input_box */
/*--------------------------------------------------------------------*/

/*
fix_boxes tries to define properties of in- and output boxes
*/
int fix_boxes(char ***line_word_array,int i_line,char *CharField_substitute)
{
 int a=0;
 static int init_local=1;
 static char *CharField_substitute0; /* pointer begin of array */
/* static int point=0; used global in global.h */
 int i;
 char string_array[10];
 static char *deepness_pointer; /* save 1st position */
 static char *size_pointer,*width_pointer,*rotate_pointer,*justif_pointer;
 /* static char *pointer; */
 int x1,y1,x2,y2; /* edges of box */
 int orientation;
 int x_position,y_position;
 int edit_coordinates=1; /* !!!!!!!!!!!!!!!!!!!!! */
  
 if (init_local) CharField_substitute0=CharField_substitute; /* store  once */
 /* get click-box (input or output-box) */
 x1=get_upper_left (line_word_array,i_line,1,3,5,7,9);
 y1=get_upper_left (line_word_array,i_line,2,4,6,8,10);
 x2=get_lower_right(line_word_array,i_line,1,3,5,7,9);
 y2=get_lower_right(line_word_array,i_line,2,4,6,8,10);
 if ( check_input_box(line_word_array,i_line,x1,y1,x2,y2,
      &orientation)==1) {/*check input , set array corner */
 } /* this is input */
 else {/* outputbox detected */
 }
#define DISTANCE_X 150
#define DISTANCE_Y 30
#define FONT_SIZE  200

  x_position=(int) x2;
  y_position=(int) y2;
  if ( (orientation==LEFT)||(orientation==RIGHT) )  { 
   if (orientation==RIGHT) x_position=x1+DISTANCE_Y;
   else                    x_position=x2-DISTANCE_Y;
   y_position-=DISTANCE_Y; 
  }
  if ( (orientation==DOWN)||(orientation==UP   ) )  { 
   x_position=(int) (0.5*(x1+x2));
   if (orientation==UP) y_position-=DISTANCE_Y; 
   else                 y_position=y1+DISTANCE_Y+FONT_SIZE;
   }
if (edit_coordinates)
 {
  /* set x-y-coordinates of box-text */
  substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_POS_X_COORD,x_position);
  substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_POS_Y_COORD,y_position);
  if (orientation==DOWN) {
   substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_COLOR_POS_TEXT,BLACK /*RED*/);
   substitute_property_in_xfig_object(line_word_array,i_line,
             CharField_substitute,&point,FONT_JUSITFICATION_POS_TEXT,CENTERED);
  }
  if (orientation==UP) {
   substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_COLOR_POS_TEXT,BLACK /*BLUE*/);
   substitute_property_in_xfig_object(line_word_array,i_line,
             CharField_substitute,&point,FONT_JUSITFICATION_POS_TEXT,CENTERED);
  }
  if (orientation==RIGHT) {
   substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_COLOR_POS_TEXT,BLACK /*CYAN*/);
   substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_JUSITFICATION_POS_TEXT,LEFT);
  }
  if (orientation==LEFT) {
   substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_COLOR_POS_TEXT,BLACK /*YELLOW*/);
   substitute_property_in_xfig_object(line_word_array,i_line,
                CharField_substitute,&point,FONT_JUSITFICATION_POS_TEXT,RIGHT);
  }
  if (a) { printf("call WriteDotXfigBox");
           WriteDotXfigBox(line_word_array,i_line);
  }
 }
  /* if ( (x2-x1)>(y2-y1) ) right=1; */
 if ( point> SUBSTITUTE_MAX-3) {
  printf("CharField_substitute>SUBSTITUTE_MAX exit"); exit (-1);
 }
  if (a) printf("read_box:line:%d ...",i_line);
  if (a) printf("converted to BOX_DEEPNESS=%d x1:%d,y1:%d x2:%d y2:%d\n"
       ,BOX_DEEPNESS,x1,y1,x2,y2);
  if (init_local) { /* write to CharField once */
   /* write string deepness to free field CharField_substitute */
   deepness_pointer=&CharField_substitute[point];
   sprintf(string_array,"%d",BOX_DEEPNESS);
   i=0; do { CharField_substitute[point++]=string_array[i++];
   } while ( string_array[i-1]!='\0');
   /* BOX_WIDTH */
   width_pointer=&CharField_substitute[point];
   sprintf(string_array,"%d",BOX_WIDTH); /* see properties_xfig.h */
   i=0; do { CharField_substitute[point++]=string_array[i++];
   } while ( string_array[i-1]!='\0');
   /* BOX_TEXT_SIZE */
   size_pointer=&CharField_substitute[point];
   sprintf(string_array,"%d",BOX_TEXT_SIZE); /* see properties_xfig.h */
   i=0; do { CharField_substitute[point++]=string_array[i++];
   } while ( string_array[i-1]!='\0');
   /* BOX_TEXT_ROTATE */
   rotate_pointer=&CharField_substitute[point];
   sprintf(string_array,"%d",BOX_TEXT_ROTATE); 
   i=0; do { CharField_substitute[point++]=string_array[i++];
   } while ( string_array[i-1]!='\0');
   /* BOX_TEXT_JUSITFICATION , see properties_xfig.h*/
   justif_pointer=&CharField_substitute[point];
   sprintf(string_array,"%d",BOX_TEXT_JUSITFICATION); 
   i=0; do { CharField_substitute[point++]=string_array[i++];
   } while ( string_array[i-1]!='\0');

   init_local=0;
  } /* init_local */
  /* swap pointers  deepness_pointer etc are created only once (init_local) */
  line_word_array[i_line]  [DEEPNESS_POS_POLYGON]=deepness_pointer; 
  line_word_array[i_line]  [WIDTH_POS_POLYGON]   =width_pointer; 
  line_word_array[i_line+2][DEEPNESS_POS_TEXT]   =deepness_pointer; 
  line_word_array[i_line+2][FONT_SIZE_POS_TEXT]  =size_pointer; 
  line_word_array[i_line+2][FONT_ROTATE_POS_TEXT]=rotate_pointer; 
  /* line_word_array[i_line+2][FONT_JUSITFICATION_POS_TEXT]=justif_pointer;  */
/*
printf("read_box:line:%s %s %s \n POLYGON_POS_X1_COORD:%s\n",
line_word_array[i_line][0],line_word_array[i_line][1],line_word_array[i_line][2],
line_word_array[i_line+1][POLYGON_POS_X1_COORD]);
*/
return (1);  
} /* int fix_boxes() */

int substitute_property_in_xfig_object(char ***line_word_array,int i_line,
                char *CharField_substitute,int *point,int prop_pos,int setvalue)
{
int a=0;
static int localinit=1;
static char *pointer;
char string_array[10]={'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};
int i;

if (localinit) {
 localinit=0;
}
if (a) printf("substitute_property_in_xfig_object: line:%d word pos:%d "
   "value:%s --> ", i_line,prop_pos,line_word_array[i_line+2][prop_pos]);

pointer=&CharField_substitute[*point];
CharField_substitute[*point]='\0';
sprintf(string_array,"%d",setvalue);
i=0; do { CharField_substitute[*point]=string_array[i++];
          *point+=1;
} while ( string_array[i-1]!='\0');
line_word_array[i_line+2][prop_pos]=pointer;
if (a) printf(" %s \n",line_word_array[i_line+2][prop_pos]);


return (1);
}

int WriteDotXfigBox(char ***line_word_array,int i_line)
{
/* int a=0; */
static int localinit=1;
/* static int counter=0; */

static FILE *dot_xfig;
char string[400];
char *word;
int i,i_word;

for (i=0;i<400;i++) string[i]='\0';


if (localinit) {
 if ((dot_xfig=fopen(".xfig","w"))==NULL) { 
  printf("WriteDotXfigBox: write-file error '.xfig' \n");exit(-1); }
 sprintf(string,"#FIG 3.2\nLandscape\nCenter\nMetric\nA4    \n100.00\n"
                "Single\n0\n1200 2\n");
 fprintf(dot_xfig,"%s" ,string);
 localinit=0; /* !!!!!!!!! set this to 1 if singel box should be printed */
}
else {
if ((dot_xfig=fopen(".xfig","a"))==NULL) { 
  printf("WriteDotXfigBox: write-file error '.xfig' \n");exit(-1); }
}

for (i=0;i<=2;i++) { /* 3 lines to write */
 i_word=0;
 do { /* write words of line */
  if (i_word>0) fprintf(dot_xfig," "); /* space before entry */
  word=line_word_array[i_line+i][i_word++];
  fprintf(dot_xfig,"%s" ,word);
 } while (line_word_array[i_line+i][i_word][0]!='\0') ;
 fprintf(dot_xfig,"\n");
}
fclose(dot_xfig);
/* if (counter++>2) exit (-1); */
return (1);
} /* WriteDotXfigBox */
