# awk script to predict load_profile
# cp load_profiles/load..dat load.dat
# awk -f ./etc/PredictLoadProfile.awk <load.dat >load_predict.dat
# paste load.dat load_predict.dat >load_profiles/load..dat
# vim load_profiles/load..dat
#
# this script makes a load prediction an sets time back
# the date base is only from 000000 to time_max-predict_time !!!
# first intervall is ignored
# paste this date base to load.dat & edit the tail
#
BEGIN { 
    n=0
    timedec=0
	timedec_old=0
	mp=0
	mp_old=0
	P_WW=0
	P_WW_old=0
	Q_WW=0
    Q_next_hour=0
    predict_time=1  #h
    time_step=0.25  # of load.dat
    time_counter=0
    Q_predict=0;
    Q_store=0
      }
{
n+=1
if (n==1) { 
          printf(" time_predict  QWW_predict \n\n");
	  }
if (n>2) {
     time_hour=int($1/1e+4)
	 time_min =int($1/1e+2-time_hour*1e+2)
	 time_sec =$1/1e+0-time_hour*1e+4-time_min*1e+2
     timedec=time_hour+time_min/60+time_sec/3600
	 mp=$2
	 TWW=$3
	 
	 P_WW=mp*4.19*(TWW-10)/3600                # kW 
	 if (mp_old>0) Q_WW+=P_WW_old*(timedec-timedec_old) # kWh
                   
     Q_predict+=P_WW*time_step; # kWh 's
     
	 P_WW_old=P_WW
	 timedec_old=timedec
	 mp_old=mp
	 
     if ( (timedec-predict_time+time_step)>=0) {
#	   printf("%f ",timedec) 
	   printf("%f ",timedec-predict_time+time_step)  #-3/4 h
#	   printf("%f ",P_WW)
       if (time_counter>=(predict_time-time_step) ) { printf("%f ",Q_predict)
                                                      Q_store=Q_predict
                                                    }
       else                                         printf("%f ",Q_store) ;

	   printf("\n")
       }
     time_counter+=time_step;
     if (time_counter>=predict_time) { time_counter=0;
                                       Q_predict=0;
                                     }
	 }
}

