#awk -f update_dekfile_with_wall_parameters.awk -vinfo=WALL_west selected_parameters_wall_01.txt sim.dek >sim.edit.dek
#
BEGIN {
 a=0; # debug
 if (a) printf("info:%s ARGV[1]:%s\n",info,ARGV[1]);
 select_unit=0; # mark parameters of selected unit
 end=-99;
 for (i=0;i<=50;i++) par[i]=end;
 i=0; # par index
 i_par=0;
}

{ # MAIN

if (FILENAME==ARGV[1]) { # read data base: FH_30/wall.dat 
 if (substr($1,1,3)=="PAR") {
  i=int($2);
  par[i]=$3;
  if (a) printf("par:%d %.4f\n",i,par[i]);
 } # PAR found
} # file 1 read
if (FILENAME==ARGV[2]) { # file 2: sim.dek
 if ( ($1=="UNIT") && (select_unit==1) ) select_unit=0; 
 for (i=1;i<=NF;i++) if ($i==info) {
   if (a) printf("info found line:%s\n",$0);
   select_unit=1;
 } # info string found
# change parameters of selected unit
 
#PARAMS 6
#*  1: [] Number of walls(limited to NR_WALLS,only Nr.1..6 with windows) 
#  6 
#*  2: [m^3] Volume of zone if no pipe_air connected 
#  129.6 
 if ($1=="INPUTS") select_unit=0; # de-select after parameter block
 if ( (select_unit==1) && ($1!="PARAMS") && ($1!="UNIT") && ($1!="*") )  {
  i_par++;
   if (a) printf("i_par:%d line:%s --> %.4f \n",i_par,$0,par[i_par]);
  if ( par[i_par]!=end) printf(" %f  # script update \n",par[i_par]);
  else                  printf("%s\n",$0); # standard line, no change
 } # par i line found
 else printf("%s\n",$0); # standard line, no change
} # file 2 read
} # MAIN
END {
# printf("\n"); #line end
}

