#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include "global.h"

/*--------------------------xfig_script_reader-------------------------*/
/*int xfig_script_reader(int *type,double **par,int **in_u,int **in_nr,
                       double **out_n,double **deriv_o
                       ,char ***line_word_array)
{
return 1;
}
*/


/*-----------------------------------------read_xfig_script------------*/
int  read_fig(char ***line_word_array,char *CharField, int field_max_dyn,
              int *unit_max,int *par_max,int *field_max,int *line_max,
              int *word_max,int *letter_max,int *deriv_max,int *input_max
              ,int *letter_max_line)
/* returns no_of lines of 'xfig_script' */
{

static int init_flag=1;
const int a=0; /*-----------------ANALYSE-PRINTS with a=1!!!!!*/

FILE *xfig_script; /* local declaration */
char ascii_line[200];
char word[50][200]; /* word of the line */
int i_line=0; /*line_counter */
int no_of_lines=0;
int i; /*counter */
int i_word; /*word_counter */
char *CharField0=CharField; /* origin */
int letter_count=0;
int word_count=0,i_word_count=0;
int letter_word=0,i_letter_word=0;

if (a) printf("read_fig:\n");

/*  put words of  each line of xfig-script to an array */
if (init_flag) /* scan array sizes out of sim.fig */
 {
 int unit_count=0;
 int par_number=0,par_count=0;
 int inp_number=0,inp_count=0;
 int deriv_number=0,deriv_count=0;
 char *pattern;

if (a) printf("words of line %d:",i_line);

 init_flag=0;
 if ((xfig_script=fopen("sim.fig","r"))==NULL)
   { printf("there's no 'sim.fig'-file !!\n");exit(-1); }
 word_count=0;
 letter_word=0;

 while (fgets(ascii_line,200,xfig_script)!=NULL)
   {
   if (strlen(ascii_line)> *letter_max_line) 
     *letter_max_line=strlen(ascii_line);

   i_line++; /*line_counter */
   if (strstr(ascii_line,"UNIT:")!=NULL) unit_count++;
   if ( (pattern=strstr(ascii_line," PAR"))!=NULL) {
     if (pattern[5]==':') par_number=-1*(48-(int) pattern[4]);
     if (pattern[6]==':') par_number=-1*(48-(int) pattern[5])
                                    -10*(48-(int) pattern[4]);
     if (a) printf("par%d found:%s \n",par_number,pattern);
     if (par_number>par_count) par_count=par_number;
     }
   if ( (pattern=strstr(ascii_line," INP"))!=NULL) {
     if (pattern[5]==':') inp_number=-1*(48-(int) pattern[4]);
     if (pattern[6]==':') inp_number=-1*(48-(int) pattern[5])
                                    -10*(48-(int) pattern[4]);
     if (a) printf("inp%d found:%s \n",inp_number,pattern);
     if (inp_number>inp_count) inp_count=inp_number;
     }
   if ( (pattern=strstr(ascii_line," DERIV"))!=NULL) {
     if (pattern[7]==':') deriv_number=-1*(48-(int) pattern[6]);
     if (pattern[8]==':') deriv_number=-1*(48-(int) pattern[7])
                                      -10*(48-(int) pattern[6]);
     if (a) printf("deriv%d found:%s \n",deriv_number,pattern);
     if (deriv_number>deriv_count) deriv_count=deriv_number;
     }

   letter_count+=strlen(ascii_line);
   i_word_count=0;
   i_letter_word=0;
   for (i=0;i<strlen(ascii_line);i++) {
     i_letter_word++;
     if (ascii_line[i]==' ') {  /* scan word */
       i_word_count++; 
       if (i_letter_word>letter_word) {
         letter_word=i_letter_word;
         if (a) printf("letter_word:%d line:%d \n",letter_word,i_line);
         }
       i_letter_word=0;
       }
     } /* scan through ascii line */
   if (i_word_count>word_count) { 
     word_count=i_word_count;
     if (a) printf("word_count:%d line:%d \n",word_count,i_line);
     }
   }
 fclose (xfig_script);
 if (a) printf("sim.fig:LETTER_MAX =%d line_max:%d word_count:%d "
        "letter_word:%d\n"
        "unit_count:%d par_count:%d   deriv_count:%d inp_max:%d\n"
        "letter_max_line:%d \n"
     ,letter_count,i_line,word_count,letter_word,unit_count,par_count
     ,deriv_count,inp_count,*letter_max_line);
 *unit_max=unit_count;
 *par_max=par_count;
 *field_max=letter_count;
 *line_max=i_line;
 *word_max=word_count;
 *letter_max=letter_word;
 *deriv_max=deriv_count;
 *input_max=inp_count;
 
/*
int field_max_dyn,
              int *unit_max,int *par_max,int *field_max,int *line_max,
              int *word_max,int *letter_max,int *deriv_max)
*/
 return 1;
 } /* end init_read */


/* dynamic allocating of line_word_array * /
line_word_array=(char***) malloc(sizeof(char**)*(i_line+1));
for (i=0;i<=i_line;i++)
  {
  line_word_array[i]     =(char**) malloc(sizeof(char*)*(WORD_MAX+1  ));
  for (i1=0;i1<=WORD_MAX;i1++)
  line_word_array[i][i1]=(char*)  malloc(sizeof(char )); 
  }
*/
if (a) printf("here is read_xfig_script");

if ((xfig_script=fopen("sim.fig","r"))==NULL)
  { printf("there's no 'sim.fig'-file !!\n");exit(-1); }

i_line=0;
/*------------------------------read each line of 'xfig_script' */
while (fgets(ascii_line,200,xfig_script)!=NULL)
{
i_line++; /*line_counter */
if (i_line>=LINE_MAX) 
     { 
     printf("read_fig.c:number of lines greater then LINE_MAX in 'global.h'");
     printf(" i_line:%d\n",i_line);
     exit(-1);
     };

/* read words of current line of fig-file */
for (i_word=0;i_word<=WORD_MAX-1;i_word++) word[i_word][0]='\0';

sscanf(ascii_line,"%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s "
                  "%s %s %s %s %s %s %s %s %s %s %s %s %s %s"
                  ,word[ 0],word[ 1],word[ 2],word[ 3],word[ 4],word[ 5]
                  ,word[ 6],word[ 7],word[ 8],word[ 9],word[10],word[11]
                  ,word[12],word[13],word[14],word[15],word[16],word[17]
                  ,word[18],word[19],word[20],word[21],word[22],word[23]
                  ,word[24],word[25],word[26],word[27],word[28],word[29]);

if (word[29][0]!='\0')
  {
  printf("read_fig:didn't read more then 30 words in line:%d \n",i_line);
  exit (-1);
  }

/* modify tabs in words */
if ( ascii_line[0] == '\t' )  /* if first letter == tab  then
                                  shift words right */
 {
   if (a) printf("tab detected \n");
   i=20;
   do    { sprintf(word[i],"%s",word[i-1]); i--;}
   while (i>=1);
   sprintf(word[0],"\t");
 }
if (strstr(word[13],"UNIT:") != NULL) { /* use 3digits unit number */
  int dummy;
  dummy=(int) strtod(word[14],NULL );
  if (a) printf("UNIT: pattern detected , "
      "filling up number string to 3 digits %d to %d\n",
         (int) strtod(word[14],NULL ),dummy);
  sprintf(word[14],"%3d",dummy );
  }



/* search 'xx\001' in word ,if yes then make a extra word for text-end */
if (a) printf("line:%s\n",ascii_line);
i_word=0;
if (strstr(ascii_line,"\\001")!=NULL)        /* search textend */
 {
 i_word=0;
 /* for (i_word=0;i_word<=(WORD_MAX-2);i_word++) */
 /* search 'x\001' words and add a space in it */
 while ( (word[i_word][0]!='\0') && (i_word<=WORD_MAX) )
   {
   if (0) printf("len:%d word[%d]:%s \n",strlen(word[i_word])
              ,i_word,word[i_word]) ;
   if (   (strstr(word[i_word],"\\001")!=NULL)
       && (strlen(word[i_word]) > 4 ) ) 
     {
     if (a) printf("separate \\001 text end from infotext \n");
     i=0;
     for (i=0;i<=LETTER_MAX;i++)
       {
       if (word[i_word][i]=='\\')
         {
         word[i_word][i]='\0'; /* cut word */
         sprintf(word[i_word+1],"\\001");  /* text end of .fig */
         if (a) printf("1st word:%s 2nd word:%s\n"
                         ,word[i_word],word[i_word+1]);
         continue;
         }
       }
     } /* end x\001 detected */
   i_word++;
   } /* end while words */
  } /* end text line detected */
/* if (i_line==23) exit (-1);*/


if (strstr(word[13],"OUT") != NULL) { /* check unit and comment */
  if (   (strstr(word[14],"\\001")!=NULL)/* there is no unit or */
       ||(strstr(word[15],"\\001")!=NULL)  /* no comment */
     )
     {
    sprintf(word[14],"[1]"); /* create unit */
    sprintf(word[15],".");
    sprintf(word[16],"\\001");
    word[17][0]='\0';
     if (a) printf("create comment in OUT: line:%d %s\n",
         i_line,ascii_line);
     }
  } /* pattern OUT */


 /* check units and comment in PAR,INP lines */
if (   (strstr(word[13],"INP") != NULL) 
     ||(strstr(word[13],"PAR") != NULL) )
  { 
  if (   (strstr(word[14],"\\001")!=NULL)/* there is no unit or */
       ||(strstr(word[15],"\\001")!=NULL)  /* no comment */
       ||(strstr(word[16],"\\001")!=NULL)  /* no comment */
     )
     {
    if (strtod(word[14],NULL)==0) sprintf(word[14],"0");
    sprintf(word[15],"[1]"); /* create unit */
    sprintf(word[16],"."); /* create comment */
    sprintf(word[17],"\\001");
    word[18][0]='\0';
     if (a) printf("create comment in PAR/INP: line:%d %s\n",
         i_line,ascii_line);
     }
  } /* pattern OUT */


/* try to write words to CharField[] array and let 
   pointers line_word_array[i_line][i_word] point to this chars 
*/
if (a) printf("write CharField\n");

if (a) printf("line:%d diff:%d diff_total:%d\n",i_line,(int) CharField
                  -(int) line_word_array[i_line-1][0]
      ,(int) CharField-(int) CharField0 );
i=0;
i_word=0;
/* while ( word[i_word][0]!='\0') / * run throu all words of this line */
do  /* run throu words of line while next word ist not empty */
{
 line_word_array[i_line][i_word]=CharField; /* point to current
                                               CharField[] */
/* line_word_array[i_line][i_word][1]='\0'; */
 /* printf("line_word_array[i_line][i_word]:%d\n"
        ,(int) line_word_array[i_line][i_word]);
 */
 i=0;
 while ( word[i_word][i]!='\0') /*string-end-label */
  {
  if (a) printf("%c:",word[i_word][i]);
  fflush(stdout);
  line_word_array[i_line][i_word][i]=word[i_word][i];
  i++;
  CharField++;
  if ( ((int) CharField-(int) CharField0)>field_max_dyn+LINE_MAX /**line_max*/ )
    { printf("\n read_fig(): CharField:%d > field_max_dyn:%d \n",
             ((int) CharField-(int) CharField0),field_max_dyn+LINE_MAX); 
      /* exit (-1); */
    }
  if (0) printf("\t CharField:%d:%d,%d,%d\t",(int) CharField
                  -(int) CharField0,i_line,i_word,i);
  } ; 
 line_word_array[i_line][i_word][i]='\0'; /* string end to this word */
 CharField++;

 if (a) printf(":%s: ",line_word_array[i_line][i_word]);
i_word++;

} while (word[i_word-1][0]!='\0') ; /* end of while , word_read */
 /* line end with \0 */
/* line_word_array[i_line][i_word]=CharField;*/
line_word_array[i_line][i_word]=CharField;
line_word_array[i_line][i_word][0]='\0';
if (a) printf("\n");

} /* end i_line of while ,line-read of xfig_script*/

line_word_array  [i_line+1][0] /* select greater fields for indexes */
 =line_word_array[i_line+2][0]
 =line_word_array[i_line+3][0]
 =line_word_array[i_line+4][0] =CharField;
line_word_array[i_line+1][0][0]='\0';

if (a) printf("CharFieldsize:%d\n",(int) CharField-(int) CharField0);

no_of_lines=i_line;

fclose(xfig_script);
if (a)
for (i_line=1;i_line<=no_of_lines;i_line++)
  {
  for (i=0;i<=5;i++)
    {
    if (line_word_array[i_line][0][i]=='\0') printf(" ");
    else printf("%c"
           ,line_word_array[i_line][0][i]);
    }
  printf("\nline_word_array: ");
  }
return (no_of_lines);
}

