#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include "global.h"

/*
020109 skip2 for '#' colors xfig bug 
*/
/*----------------------------------write xfig_script------------------*/
int write_fig(
               char    ***line_word_array,
               int     no_of_lines,
               int     **compound_coordinates,
               int     **connection,
               int     **x_connection,
               int     **y_connection,
               int     AutoRouter_flag
             )
{
/* 
writes 'sim_new.fig' from current (modified) line_word_array.
if AutoRouter_flag is set , all registred connection are
substituded by new routed connection via WriteXfigConnection()
(auto_router.c)

*/

int a=0; /* debug with 1 */
FILE *new_xfig_script; /*xfig-file*/
int i;
int i_line,i_word;
int i_connection=0;
int connection_line_min=1e8;
int skip=0,skip2=0;
char line_string_field[400];
char *line_string;
int DotXfig_flag=0; /* write lines to .xfig */

line_string= (char*) line_string_field;


do {
 if (connection_line_min>connection[i_connection][I_LINE])
     connection_line_min=connection[i_connection][I_LINE];
} while (connection[++i_connection][1]!=END);

if ((new_xfig_script=fopen("sim_new.fig","w"))==NULL)
  { printf(" write-error new_xfig_script\n");exit(-1); }

/*write out word for word*/
for (i_line=1;i_line<=no_of_lines;i_line++)
{
i_connection=0; 
skip=0; /* check this line to skip if auto_router was active */
do { if (i_line==connection[  i_connection][I_LINE]) skip=1;
   } while ( (!skip) && (connection[++i_connection][1]!=END));
if (   (line_word_array[i_line][0][0]!='\0') 
     &&(line_word_array[i_line][1][0]!='\0')
     &&(line_word_array[i_line][2][0]!='\0')
   ) 
   { /* user color bug of xfig */
   if ( strstr(line_word_array[i_line][2],"#")!=NULL) skip2=1; 
   else skip2=0;
   }

if ((skip)&&(AutoRouter_flag) ) 
  i_line+=connection[i_connection][I_LINE_OFFSET]-1;
if ( (a) && (skip) ) printf("i_line:%d=%d offs:%d no_of_lines:%d\n"
  ,i_line,connection[i_connection][I_LINE],
   connection[i_connection][I_LINE_OFFSET],no_of_lines);     
if (i_line>no_of_lines) { printf("write_fig: error i_line:%d skip\n",
   i_line); exit (-1); }


if ( (!skip) && (!skip2) )  {
 i_word=0;
   /* not empty word */
 while (  ( line_word_array[i_line][i_word][0]!='\0')
        &&(i_line<=no_of_lines) 
       )
  {
  i=0;
    /*string-end-label */
  if (i_word>0) fprintf(new_xfig_script," "); /* space before eord */
  if (a) printf(" ");
  while ( line_word_array[i_line][i_word][i]!='\0')
   {
   if (a) printf("%c",line_word_array[i_line][i_word][i]);
   fprintf(new_xfig_script,"%c",line_word_array[i_line][i_word][i]);
   i++;
   }
  i_word++;
  } /*end of while , word_read */
 if (i_word>0) fprintf(new_xfig_script,"\n"); /* next line */
} /* if !skip */
else { 
 if (skip2==0) {
 /* get substituded lines */
 WriteXfigConnection(line_string,line_word_array,connection
                    ,i_connection, x_connection,y_connection,DotXfig_flag);
 fprintf(new_xfig_script,"%s",line_string);
 }
}

if (a) printf("\n");
} /* next i_line */

fclose(new_xfig_script);
if (a) printf("fclose new_xfig_script \n");

return 1;
}
/*---------------------------------------------------------------------*/
/*
int write_connection(line_word_array,connection,i_connection,x_connection
                ,y_connection)
{
WriteXfigConnection(line_string,line_word_array,connection
                    ,i_connection, x_connection,y_connection,DotXfig_flag);

}
*/
