# nehme modifizierten Sum_energy_awk , bei dem die Spaltennummer in $1 steht
# kopiere alle varianten nacheinander in eine Datei mit:
# etc/Sum_Energy_Year.awk <system-5/sim_out1.dat >>Jahresenergie.dat
#
# Balkendiagramm.awk <Jahresenergie.dat >Jahresenergie.balken.dat
# gnuplot : set boxwidth 0.1
# plot [0.5:5.5] 'Jahresenergie.balken.dat' us 1:2 ti 'Q_sonne' wi boxes
# !!! reload exportet XFIG2.1 Object in XFIG and save it in 3.2 Format !!!
# fill boxes with: sed -e "s/0 -1 0.000 0 0 0 0 0/0 20 0.000 0 0 0 0 0/g"
# search "2 1" and fill box at $5 from -1 to 0 , $9 to -1 
# pencolor = $5 0:black 1:blue ...
# fill color =$6 0:black 1:blue -1:default for pattern fill ! 7:white  
# fillmode pattern $9 to 41:pattern 42:pattern2 ... 20:filled
# dashed line : $10 solid:0.000 dashed:4.000
# 
# pen $5 to 10
# fill $6 to white 7
# fillpattern $9 to 41:pattern 42:pattern2
# dashed to solid $3 to 0, 
# search frame: "2 1 0 1" and x2=$3>1000+x1=$1
# awk '{ if ( (this==1) && ($3>$1+1000) ) { printf("%s:%s\n",$0,$1);this=0; } ; if ( ($1==2) && ($2==1) && ($3==0) ) this=1;}' <flabeg.balken.fig | more
# 
awk '
BEGIN {
 balken[1]=1  # column 1
 balken[2]=2  # column 2
 balken[3]=4  
 balken[4]=5
 balken[5]=15
 balken_max=5
 variante=1
 }
{ 
number=$1
if (number_old>number) {variante=variante+1; printf("\n"); }
column_entry=0;
if ($1==balken[1])  column_entry=1
if ($1==balken[2])  column_entry=2
if ($1==balken[3])  column_entry=3
if ($1==balken[4])  column_entry=4
if ($1==balken[5])  column_entry=5
if (column_entry>0) {
   xpos=variante-0.5+column_entry*(1/(balken_max+1));
   printf("%.4f ",xpos);
   if (column_entry>1) { for (i=1;i<column_entry;i++) printf("0 "); }
   printf("%s ",$2);
   if (column_entry<balken_max) {
         for (i=(column_entry+1);i<=balken_max;i++) printf("0 ");
         }
   printf("\n");
   }

number_old=number;
}'


