# awk -f Q_FW.awk daily.dat >daily_energies.dat
# gnuplot: plot "daily_q_fw.dat" us 2:3 wi li,"" us 2:7 wi li,"" us 2:8 wi li
#          plot "daily_q_fw.dat" us 2:3 wi li ,"" us 2:4 wi li,"" us 2:5 wi li
#
# awk -f boxes.awk -v x=2 -v dx=1 -v dy1=36 -v dy2=37 -v dy3=35 -v offs=0    -v f=-1 $HOME/tmp/daily.dat >boxes2.gnu.dat
#
BEGIN {
a=0;
printf("#TIME TIME_OF_DAY Q_loss_Sp1 Q_WP_abluft Q_FW Q_Koll2 Q_WP Q_FW_new\n");
}
{
# 
T_Sp1_1=$39
T_Sp1_2=$40
T_Sp1_3=$41
T_Sp1_4=$42
T_Sp1_5=$43

T_mean_1=( T_Sp1_1+T_Sp1_2+T_Sp1_3+T_Sp1_4+T_Sp1_5 ) /5;
Q_loss_Sp1=(T_mean_1-20)*7.5*24/1000 # kWh / d 

Vp_Abluft_int=$47 #integral
T_Ab_WPin    =$45
T_Ab_WPout   =$46
Q_WP_abluft = 0.34*2*Vp_Abluft_int/24.0*(T_Ab_WPout-T_Ab_WPin);

#printf("%s %s %f %f %f %f %f %f\n",$1,$2,T_Sp1_1,T_Sp1_2,T_Sp1_3,T_Sp1_4,T_Sp1_5,Q_loss_Sp1);
#printf("%s %s %f %f %f %f\n",$1,$2,Vp_Abluft_int,T_Ab_WPin,T_Ab_WPout,Q_WP_abluft);

Q_WP=$35
Q_FW=$36;
Q_Koll2=$37;
Q_Htg=$32;
Q_SpWT1=$38;


if (Q_FW>50) Q_FW_new=Q_Htg+Q_SpWT1+Q_loss_Sp1-Q_Koll2-Q_WP
else         Q_FW_new=Q_FW                                             #not in summer time

printf("%s %s %f %f %s %s %s %f\n",$1,$2,Q_loss_Sp1,Q_WP_abluft,Q_FW,Q_Koll2,Q_WP,Q_FW_new);
}
